/***
 * uGASP location based demonstrator.
 * Copyright (C) 2008 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin
 */
//#include parameters.h
////////////////////////
// Compile params     //
////////////////////////



////////////////////////
// Game params        //
////////////////////////

////#define PING
////#define VIRTUAL_WORLD_MAP

////////////////////////
// Mobile Ajax params //
////////////////////////


////////////////////
// Logging params //
////////////////////

// enable to log in a mobile phone file (Nokia videos folder)
// we used the JSR75 
////#define LOG_FILE 


//#endinclude
package org.ugasp.demonstrator.client;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.bluetooth.BluetoothStateException;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotOpenException;

import org.ugasp.demonstrator.ChatMessageBroadcast;
import org.ugasp.demonstrator.ChatMessageMulticast;
import org.ugasp.demonstrator.ChatMessageUnicast;
import org.ugasp.demonstrator.client.game.GameCanvas;
import org.ugasp.demonstrator.client.game.SimpleGameCanvas;

//#ifdef GPS_BLUETOOTH
//# import org.ugasp.location.Discovery;
//# import org.ugasp.location.GPSInfo;
//# import org.ugasp.location.GPSInfo.Listener;
//#endif GPS_BLUETOOTH

//#ifdef GPS_SIMULATOR
import org.ugasp.location.simulator.GPSProvider;
//#endif GPS_SIMULATOR

/**
 * @author Cybernash, Maxime Wozny ,Alexandre Garc�, Moez Habib Thameur, Franck CARON
 */
public class IHMGasp /*extends GASPClient*/ implements CommandListener,
        Runnable, 
        //#ifdef GPS_BLUETOOTH
        //# GPSInfo.Listener 
        //#endif GPS_BLUETOOTH
        //#ifdef GPS_SIMULATOR
        GPSProvider.Listener 
        //#endif GPS_SIMULATOR
        {
	/**
	 * The linked midlet
	 */
    protected App app;
  
    /**
	 * RMS
	 */ 
    private RecordStore recStore = null;
    private String dbRMS ="db_User1";
    
    /**
     * GASP ID 
     */ 
    private int aID;
    private int sID;
    public int aSID;
    	
    /**
     * GASP Infos
     */
    public boolean isOwner;
    private boolean isChangePseudo = false;
    private int ownerASID;
    private int[] currentAIIDList;
    private Vector appInstances;
  //  private Vector gameSessionPlayers;
    private boolean firstPlayer;
  //  private Integer integer;
    public String pseudoname;
    private int minActors=0;
    private int maxActors=0;
    private int min;
    
    private Hashtable htGameSessionPlayers;

    
    /**
     * mode, player is in:
     * 0 -> mainscreen
     * 1 -> lobby 
     * 2 -> waitingRoom
     * 3 -> inGame
     */
    public int mode; 
    
    
    /** 
     * Display all the vars
     */
    private Display display;
    private List list;
    
    private TextBox t;
    private Displayable customScreen;
    
    private StringItem si = new StringItem("","");
    private StringItem version = new StringItem ("Version:"," 1.0.3");
    //private StringItem gaspProject = new StringItem(" ","                             ");

    private StringItem priv = new StringItem("Note:","If you want to create a private game, enter the authorized actors."+ "Please follow this pattern: 1_50_10_45_2");
    private TextField tfLogin = new TextField("Login:   ", "", 10, TextField.ANY);
    private TextField tfPwd = new TextField("Password:", "", 10, TextField.ANY);
    private TextField tfPseudo = new TextField("Pseudo:", "", 10, TextField.ANY);
    private TextField tfMin = new TextField("Minimum:", "", 10, TextField.NUMERIC);
    private TextField tfMax = new TextField("Maximum:", "", 10, TextField.NUMERIC);
    private TextField tfPriv = new TextField("Authorized actors:", "", 40, TextField.ANY);
   
    private TextField tfMsg = new TextField("Enter your message:", "", 50, TextField.ANY);
    private TextField tfChat = new TextField("Chat:", "", 200, TextField.ANY);
    
    private Form formLogin = new Form("GASP log on");
    private Form formWaitingRoom = new Form("Waiting Room");
    private Form formPseudo = new Form("Options");
    private Form formMsg = new Form("Chat");
    private Form formMinmax = new Form("Number of players");
    
    private ChoiceGroup players;
    
    private Command currentCommand;
    private Thread commandThread;
    
    
    /**
     * quit the midlet
     */
    private Command exitCommand  = new Command("Exit", Command.EXIT, 2);
    
    /**
     * join the application instance selected in the list in the Lobby
     */
    private Command joinCommand = new Command("Join", Command.ITEM, 1);
    
    /**
     * login with the username and the password typed in the login screen
     */
	private Command loginCommand = new Command("Login", Command.SCREEN, 1);
	
	/**
	 * refesh the list of application instances in the Lobby
	 */
    private Command lobbyRefreshCommand = new Command("Refresh", Command.SCREEN, 1);
    
    /**
     * go to the new game creation screen when you are in the Lobby
     */
    private Command createCommand = new Command("Create", Command.SCREEN, 1);
    
    /**  
     * send data when you are in game
     */
    private Command dataCommand = new Command("SendData", Command.SCREEN, 1);
    
    /**
     * get the last events in the application instance when you are in 
     * the waiting room or in game
     */
    private Command eventsCommand = new Command("GetEvents", Command.SCREEN, 1);
    
    /**
     * starts the game when you are in the waiting room
     * the owner should be the only one allowed to use this command
     */
    private Command messageCommand = new Command("Send Message", Command.SCREEN, 1);
    
    
    /**
     * starts the game when you are in the waiting room
     * the owner should be the only one allowed to use this command
     */
    private Command sendCommand = new Command("Send", Command.SCREEN, 1);
   
    
    /**
     * starts the game when you are in the waiting room
     * the owner should be the only one allowed to use this command
     */
    private Command startCommand = new Command("Start Session", Command.SCREEN, 1);
    
    /** 
     * stop the game and return to the waiting room
     * the owner should be the only one allowed to use this command 
     */
    private Command endCommand = new Command("End Session", Command.SCREEN, 1);
    
    /**
     * quit GASP and return to the login screen
     */
    private Command quitCommand = new Command("Quit", Command.SCREEN, 1);
    
    /**
     * quit the application instance and retrun to the Lobby
     */
    private Command quitAICommand = new Command("Quit Session", Command.SCREEN, 1);
    
    /**
     * allow you to change your pseudo
     */
	private Command pseudoCommand = new Command("Options", Command.SCREEN, 1);
	
	/**
	 * used to confirm your new pseudo in the pseudo screen
	 */
	private Command okCommand = new Command("Ok", Command.SCREEN,1);
	
	/**
	 * used to cancel the choice you are currently doing (pseudo change or game creation)
	 */
	private Command cancelCommand = new Command("Cancel", Command.SCREEN, 1);
	
	/**
	 * when you are in the new game creation screen, create a game with the
	 * parameters you have chosen 
	 */
	private Command confirmCommand = new Command("Create", Command.SCREEN,1);

   
    /** Initialize the MIDlet with a handle to the current display */
    public IHMGasp(App m) {
        app = m;
        display = Display.getDisplay(app);
        appInstances = new Vector();
        isOwner = false;
        htGameSessionPlayers = new Hashtable();
        mode = 0;
    	
        /**
         * build GASP login form
         */ 
        si.setLayout(Item.LAYOUT_CENTER);
        tfLogin.setPreferredSize(90,35);
        tfLogin.setLayout(Item.LAYOUT_CENTER);
        tfPwd.setPreferredSize(90,35);
        tfPwd.setLayout(Item.LAYOUT_CENTER);
    	version.setLayout(Item.LAYOUT_NEWLINE_AFTER);
        
    	formLogin.append(si);
        try{
    		formLogin.append(Image.createImage("/gasp.png"));
    	}catch (Exception e){}
        
        formLogin.append(tfLogin);
    	formLogin.append(tfPwd);
 
    	//gaspProject.setLayout(Item.LAYOUT_NEWLINE_AFTER);
    	//formLogin.append(gaspProject);
    	// add GASP research team logos
    	try{
    		formLogin.append(Image.createImage("/cnam.gif"));
    		formLogin.append(Image.createImage("/int.gif"));
    	}catch (Exception e){}
    	 	
       	formLogin.append(version);
    	formLogin.addCommand(loginCommand);
    	formLogin.addCommand(exitCommand);
    	
    	formLogin.setTitle("uGASP demonstrator");
    	
    	/**
    	 *  build GASP Minmax form
    	 */
    	formMinmax.append(tfMin);
    	formMinmax.append(tfMax);
    	formMinmax.append(priv);
    	formMinmax.append(tfPriv);
        formMinmax.addCommand(confirmCommand);
    	formMinmax.addCommand(cancelCommand);
    	
    	/**
    	 *  build GASP Pseudo form
    	 */
    	formPseudo.append(tfPseudo);
        formPseudo.addCommand(okCommand);
    	formPseudo.addCommand(cancelCommand);
    	
    	/**
    	 *  build GASP Chat form
    	 */
    	formMsg.append(tfMsg);
        formMsg.addCommand(sendCommand);
    	formMsg.addCommand(cancelCommand);
    }
    /**
     * Debug output routine.
     * @param s string to be printed.
     */
    static final void DEBUG(String s) {
        if (true) {
            System.out.println(s);
        }
    }
      
    /**
     * Pause signals the thread to stop by clearing the thread field.
     * If stopped before done with the iterations it will
     * be restarted from scratch later.
     */
    public void startApp() {
        currentScreen();
    }
 
    /**
     * Respond to commands, including exit
     * @param c command to perform
     * @param s Screen displayable object
     */
    public void commandAction(Command c, Displayable s) {
        synchronized (this) {
            if (commandThread != null) {
                /**
                 *  process only one command at a time
                 */
                return;
            }
            currentCommand = c;
        	commandThread = new Thread(this);
        	commandThread.start();
        }
    }
    
    
    public void run() {
    	try{
        if (currentCommand == exitCommand) {
            app.notifyDestroyed();
        } else if (currentCommand == loginCommand) {
        	if ("".equals(tfLogin.getString())){
        		alertScreen("To be connected to the Gasp platform, you must fill the login field");
        	}
        	else login(tfLogin.getString(),tfPwd.getString());
        	
        	//#ifdef GPS_SIMULATOR
        	if (sID>0) mode=1;
        	//#endif GPS_SIMULATOR
        	//#ifdef GPS_BLUETOOTH
        	//# if (sID>0) mode=5;
        	//#endif GPS_BLUETOOTH
        	else alertScreen("Session has not been created");
        	
        	currentScreen();
    	} else if (currentCommand == joinCommand) {
    	    join();
    	    if (aSID != 0) mode = 2;
    	    else alertScreen("This game session is no more joinable.");
        	currentScreen();
        } else if (currentCommand == createCommand) {
            createScreen();
        } else if (currentCommand == lobbyRefreshCommand) {
    	    currentScreen();
    	} else if (currentCommand == quitCommand) {
            if (isOwner){
            	if (mode == 2){
            	    //quitAI();
            		removeAllPlayers();
            		//gameSessionPlayers.removeAllElements();
              		// networkCom.quitAI(aSID);
              	}
            	mode = 0;
            	quit();
        	    aSID=0;
        		
            }
            else if (mode!= 1){ 
                networkCom.quitAI(aSID);
                aSID = 0;
                removeAllPlayers();
        	    //gameSessionPlayers.removeAllElements();
            }
            networkCom.quit(sID);
            mode = 0;
            tfPwd.setString("");
            currentScreen();
        } else if (currentCommand == eventsCommand) {
        	networkCom.getEvents(aSID);
    	} else if (currentCommand == startCommand) {
        	if (networkCom.startAI(aSID)){
        		startGame();
        		isOwner = true;
        	}
        	else {
        		alertScreen("You cannot start the game. Minimum of players is "+min);
        		mode=2;
        	}        	
        	currentScreen();
    	} else if (currentCommand == dataCommand) {
        	currentScreen();
    	} else if (currentCommand == endCommand) {
    		networkCom.endAI(aSID);
        	mode = 2;
    	    currentScreen();
    	} else if (currentCommand == quitAICommand) {
    		networkCom.quitAI(aSID);
    		this.quitAI();
    		aSID = 0;
    		removeAllPlayers();
    	    //gameSessionPlayers.removeAllElements();
    	    mode = 1;
    	    currentScreen();
    	} else if (currentCommand == pseudoCommand) {
    	    changePseudoScreen();
    	} else if (currentCommand == messageCommand) {
    	    sendMessageScreen();
    	} else if (currentCommand == sendCommand) {
    		sendMessage();
        	currentScreen();
    	} else if (currentCommand == okCommand) {
    		changePseudo();
    	    currentScreen();
    	} else if (currentCommand == cancelCommand) {
    		cancelValue();
       	}else if (currentCommand == confirmCommand) {
    		firstPlayer = true;
    		isOwner = true;
    		create();	
    	}
        //#ifdef GPS_BLUETOOTH
       	//# else if (currentCommand == get_connectCommand()) {
            //# doConnect();
        //# }
        //#endif GPS_BLUETOOTH
      
    	}catch (Exception e){ e.printStackTrace();}

        synchronized (this) {
            // signal that another command can be processed
            commandThread = null;
        }
    }
 
    /**
     * 
	 * This method is called when a player try to create a game session.
	 * A player can create a public game session or a private game session
	 * 
	 */
   
	private void create() {
		try {
			String minActorsTxt = tfMin.getString();
			String maxActorsTxt = tfMax.getString();
			String actorsHttp = tfPriv.getString();
			if ("".equals(minActorsTxt)){
				minActors = 0;
			}
			else if ("".equals(maxActorsTxt)){
				maxActors = 0;
			}
			else {
				minActors = Integer.parseInt(tfMin.getString());
				maxActors = Integer.parseInt(tfMax.getString());
			}
			if (minActors==0){
				alertScreen ("A multiplayer game begins with 2 players!!!!");
				createScreen();
			}
			else if (minActors>maxActors || maxActors<=0){
				alertScreen ("The session could not be created. Min > Max");
				createScreen();
			}
			else if (maxActors >0 /*"".equals(actorsHttp)*/){
					aSID = networkCom.createAI(sID,minActors,maxActors);
					min=minActors;
					mode =2;
					currentScreen();
				}
			else if (! "".equals(actorsHttp)){
					/**TODO: private session  /aSID = createAIPriv(sID,actorsHttp,minActors,maxActors);*/
						alertScreen("create private session is not implemented...");
						min = minActors;
						createScreen();
					}
		}
		catch (NumberFormatException e){
			alertScreen("The session cannot be started. Min or Max are not valid");
			maxActors=0;
			minActors=0;
			createScreen();
			e.printStackTrace();
		}
	}

	/**
     * Set the funtion to perform based on commands selected.
     * @param d Displayable object 
     * @param isLobby flag to indicate list processing
     */
    void setCommands(Displayable d, int commandMode) {
        switch (commandMode){
        	case 0: 
        	    d.addCommand(loginCommand);
        	    break;
        	    
        	case 1: 
        		/**
        		 *  Lobby with currently no sessions commands
        		 */
        	    d.addCommand(createCommand);
                d.addCommand(lobbyRefreshCommand);
                d.addCommand(quitCommand);
                break;
        	    
        	case 2: 
        		/**
        		 * Lobby with currently sessions commands
        		 */ 
        	    d.addCommand(joinCommand);
                d.addCommand(createCommand);
                d.addCommand(lobbyRefreshCommand);
                d.addCommand(quitCommand);
        	    break;
        	    
        	case 3: 
        		/**
        		 * Waiting room commands
        		 */ 
        		//#ifdef DEMO
        	    //# d.addCommand(eventsCommand);
        	    //#endif DEMO
        		d.addCommand(messageCommand);
        	    d.addCommand(pseudoCommand);
                if (isOwner) d.addCommand(startCommand);
                d.addCommand(quitAICommand);
                d.addCommand(quitCommand);
        	    break;
        	    
        	case 4: 
        		/**
        		 * In Game room commands
        		 */ 
        	    d.addCommand(eventsCommand);
                d.addCommand(dataCommand);
                if (isOwner) d.addCommand(endCommand);
                d.addCommand(quitAICommand);
                d.addCommand(quitCommand);
        	    break;
        	         	            	    
        	default: break;
        }
        d.setCommandListener(this);
    }

    /**
     * This methods provides to draw the appropriate screen.
     */
    public void currentScreen() {
        switch (mode){
        	case 0:
        	    mainScreen();
        	    break;
        	case 1:
        	    lobbyScreen();
        	    break;
        	case 2:
        	    waitingRoomScreen();
        	    break;
        	//#ifdef GPS_BLUETOOTH
        	//# case 5:
        	    //# bluetoothGPSConnectionScreen();
        	//#endif GPS_BLUETOOTH
        	    
        	    
        	default: break;	    
        } 
    }
   
    /**
     *  Link to the network communication object
     */
    private NetworkCom networkCom;
    
    /**
     *  Link to the network communication object
     */
    private MapCom mapCom;
    
    /**************************************/
    /********* Displays management ********/
    /**************************************/
   
    /**
     * Main screen.
     */
    void mainScreen() {
        formLogin.setCommandListener(this);
    	display.setCurrent(formLogin);
    	networkCom = new NetworkCom(this);
    	mapCom = new MapCom(this);
        tfPwd.setString("");
    }
    
    /**
     * Lobby screen.
     */
    void lobbyScreen() {
    	try{
    	    firstPlayer = false;
    	    isOwner = false;
    	    appInstances = networkCom.getApplicationInstances(sID);
    	    //System.out.println(" il y a un pb dans le lobby?");
	    	int  indexMax = appInstances.size();
	    	//System.out.println(" il y a 2 pb dans le lobby?");
	    	currentAIIDList = new int[indexMax];
	    	//System.out.println(" il y a 3 pb dans le lobby?");
	    	
	    	if (indexMax == 0){
	    	    String s = "Note: Currently no game sessions to join";
	    	    t = new TextBox("GASP: Lobby Room", s, s.length(), 0);
	    	    setCommands(t, 1);
	    	    t.setCommandListener(this);
	    	    display.setCurrent(t);
	    	}
	    	else{
	    	    list = new List("GASP: Lobby Room", Choice.EXCLUSIVE);
	    	    list.setCommandListener(this);
	    	    list.append("Random session", null);
	    	    
		        for (int i = 0; i < appInstances.size(); i++) {
		            ApplicationInstanceInfos appInfos = (ApplicationInstanceInfos)appInstances.elementAt(i);
		            currentAIIDList[i] = appInfos.getApplicationInstanceID();
		            int aIID = appInfos.getApplicationInstanceID();
		            int nbP = appInfos.getNbPlayers();
		            int min = appInfos.getMinActors();
		            int max = appInfos.getMaxActors();
		            list.append("ApplicationInstanceID: "+aIID+ " nbPlayers: "+min+"/"+ nbP+"/"+ max, null);
		        }
		        setCommands(list, 2);
		        display.setCurrent(list);
	    	}
    	}
    	catch (Exception e){e.printStackTrace();}
    }
    
    /**
     * Waiting room screen.
     */
    void waitingRoomScreen() {
        try{
        	networkCom.startComThread();
        	formWaitingRoom.deleteAll();
        	players = new ChoiceGroup("Players", Choice.MULTIPLE);
        	
	    	//list = new List("Waiting Room - Players", Choice.MULTIPLE);
        	//list.setCommandListener(this);
	    	Enumeration enume= htGameSessionPlayers.keys();
	    	while (enume.hasMoreElements()){
	    		short pid = Short.parseShort((String) enume.nextElement());
	     		if (pid == ownerASID){
	     			if (ownerASID== aSID) 
	     				players.append("Owner(you): "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")",null);
	     			else
	     				players.append("Owner: "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")",null);   
	     		}
	     		else {
	     			if (pid == aSID){
	     				players.append("Player(you): "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")",null);
	     			}
	     			else 
	     				players.append("Player: "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")",null);
	     			}
	    	}
	    	
	    	setCommands(formWaitingRoom, 3);
	    	formWaitingRoom.append(players);
	    	formWaitingRoom.append(tfChat);
            display.setCurrent(formWaitingRoom);
    	}
    	catch (Exception e){e.printStackTrace();}
    }
        
    
    //#ifdef GPS_BLUETOOTH
    //# /**
     //# * Bluetooth GPS connection screen.
     //# */
    //# void bluetoothGPSConnectionScreen() {
    	//# try{
            //# display.setCurrent(get_mainForm());//GEN-LINE:MVDInitInit
            //# doDiscovery();
    	//# }
    	//# catch (Exception e){e.printStackTrace();}
    //# }
    //#endif GPS_BLUETOOTH
    
    
    
	/**
	 * Create screen
	 * Perform a GASP create form to have min and max players
	 * + private game authorized actors list if necessary
	 */
	void createScreen() {	
        try{
    		tfMin.setString("");
    		tfMax.setString("");
    		tfPriv.setString("");
        	formMinmax.setCommandListener(this);
        	display.setCurrent(formMinmax);
        	
    	}
    	catch (Exception e){e.printStackTrace();}
    }

    
    /**
     * ChangePseudo screen.
     */
    void changePseudoScreen() {
        try{
        	pseudoname = networkCom.name(aSID,tfPseudo.getString());
        	tfPseudo.setString(""+htGameSessionPlayers.get(""+aSID));
        	//tfPseudo.setString((String) gameSessionPlayers.elementAt(getIndex(aSID)+1));
        	DEBUG("Pseudo:"+tfPseudo.getString());
        	formPseudo.setCommandListener(this);
	    	display.setCurrent(formPseudo);
	    	isChangePseudo = true;
    	}
    	catch (Exception e){e.printStackTrace();}
    }
    
    
    /**
     * Send message screen.
     */
    void sendMessageScreen() {
        try{
        	tfMsg.setString("");
        	formMsg.setCommandListener(this);
	    	display.setCurrent(formMsg);
    	}
    	catch (Exception e){e.printStackTrace();}
    }
    
    /**
     * In Game screen.
     */
   /* void inGameScreen() {
        try{
        	networkCom.getEvents(aSID);
	    	list = new List("In Game", Choice.EXCLUSIVE);
	    	list.setCommandListener(this);
	        for (int i = 0; i < gameSessionPlayers.size(); i++) {
	            Integer aSIDOf = (Integer)gameSessionPlayers.elementAt(i);
	            if (aSIDOf.intValue()== ownerASID){
	                if (ownerASID == aSID)
	                    list.append("Owner(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	     
	                else
	                    list.append("Owner: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);
	            }
	            else{
	                if (aSIDOf.intValue()== aSID)
	                    list.append("Player(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	                else 
	                    list.append("Player: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);	
	            }
	            i++;
	    	}
	        setCommands(list, 4);
	        display.setCurrent(list);
    	}
    	catch (Exception e){e.printStackTrace();}
    }*/
      
    /**
     * Alert screen.
     */
    synchronized void alertScreen(String s) {
        t = new TextBox("Alert", s, s.length(), 0);
        display.setCurrent(t);
        try {
            Thread.sleep(1300);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
    
    /**
     * Cancel command 
     * Go back to previous screen (lobby screen or inGame screen)
     */
    private void cancelValue(){
    	if (isChangePseudo){
    		changePseudo();
    		waitingRoomScreen();
    		isChangePseudo = false;
    	}
    	else {
    		tfMin.setString("");
    		tfMax.setString("");
    		lobbyScreen();
    	}  		
      }
    
    private Vector sList;
    
    /**
     * Test the change pseudo function.
     */
	private void sendMessage() {
    	boolean[] selected = new boolean[htGameSessionPlayers.size()];
    	players.getSelectedFlags(selected);
    	
    	int nbSelected = 0;
    	sList = new Vector();
    	
    	for(short i=0; i<selected.length; i++){
    		if (selected[i]){
    			sList.insertElementAt(new Short(getPlayerASID(i)), sList.size());
    			nbSelected++;
    		}
    	}
    	
    	if (nbSelected == selected.length) sendBroadcastMessage(tfMsg.getString());
    	else if (nbSelected > 1) sendMulticastMessage(sList,tfMsg.getString());
    	else if (nbSelected == 1) sendUnicastMessage((Short)sList.elementAt(0),tfMsg.getString());
    	   	
    	/*if (pseudoname.equals("")) gameSessionPlayers.setElementAt(tfPseudo.getString(),getIndex(aSID)+1);
    	else gameSessionPlayers.setElementAt(pseudoname,getIndex(aSID)+1);*/
    	currentScreen();
    }
    
    
    private void sendUnicastMessage(Short recipient, String s) {
		System.out.println("Send message to player id: "+recipient.shortValue());
    	ChatMessageUnicast msg = NetworkCom.newChatMessageUnicast();
    	msg.setId((short)aSID);
    	msg.setRecipient(recipient.shortValue());
    	msg.setTxt(s);
		NetworkCom.addSend(msg);
		
	}
	private void sendMulticastMessage(Vector selectedList, String s) {
		ChatMessageMulticast msg = NetworkCom.newChatMessageMulticast();
		short[] recipients = new short[selectedList.size()];
		for(int i=0; i<selectedList.size(); i++) recipients[i] = ((Short) selectedList.elementAt(i)).shortValue();
		msg.setId((short)aSID);
		msg.setRecipients(recipients);
    	msg.setTxt(s);
		NetworkCom.addSend(msg);
		
	}
	private void sendBroadcastMessage(String s) {
		ChatMessageBroadcast msg = NetworkCom.newChatMessageBroadcast();
		msg.setId((short)aSID);
		msg.setTxt(s);
		NetworkCom.addSend(msg);
		
	}

	/**
     * Test the change pseudo function.
     */
    private void changePseudo() {
    	pseudoname = networkCom.name(aSID,tfPseudo.getString());
    	if (pseudoname.equals(""))htGameSessionPlayers.put(""+aSID,tfPseudo.getString());
    	else htGameSessionPlayers.put(""+aSID,pseudoname);
    	   	
    	/*if (pseudoname.equals("")) gameSessionPlayers.setElementAt(tfPseudo.getString(),getIndex(aSID)+1);
    	else gameSessionPlayers.setElementAt(pseudoname,getIndex(aSID)+1);*/
    	currentScreen();
    }

    
    /*********************************************/
    /****** specific informations for GASP *******/
    /*********************************************/
    
    /**
     * The application ID on GASP
     */
    private static final int applicationID = 2;
    
    /**
	 * Perform a GASP firstLogin or login,
	 * pick an alert screen and go to lobby screen.
	 */
	private void login(String loginName, String pwd) {
	    openRecordStore();
		byte[] aIDBytes = null;
		String aIDs = "";
		int nb = 0;
		try {
			nb = recStore.getNumRecords();
			
			//if (nb==0){
				int actorID = networkCom.firstLogin(applicationID,loginName,pwd);
				DEBUG("firstLogin called with aID="+actorID);
				aIDs = "aID"+actorID;
				aIDBytes = aIDs.getBytes();
				recStore.addRecord(aIDBytes,0, aIDBytes.length);
			//}
			//else{
			    
				/*aIDBytes = recStore.getRecord(1);
				aIDs = new String(aIDBytes,0,aIDBytes.length);
				DEBUG("login called with aID="+aIDs);*/
			//}
			
			int i = aIDs.length();
			aIDs = aIDs.substring(3,i);
			aID = Integer.parseInt(aIDs);
			sID = networkCom.login(aID,loginName,pwd,"2.0");
			DEBUG("login ok: sID n�"+sID);
			nb = recStore.getNumRecords();
		} 
		catch (RecordStoreNotOpenException e) {
			e.printStackTrace();
		}
		catch (RecordStoreFullException e) {
			e.printStackTrace();
		}
		catch (RecordStoreException e) {
			e.printStackTrace();
		}
		catch (Exception e){
			e.printStackTrace();
		}
		alertScreen("Your infos : ActorID>"+aID+" Session ID>"+ sID);
	}
	
	/**
	 * Perform a GASP joinAIRnd or joinAI,
	 * and go to waitingRoomScreen.
	 */
	private void join() {
		if (list.getSelectedIndex()==0){
			/**
			 * join random option selected
			 */
			aSID = networkCom.joinAIRnd(sID);
		}
		else{
			aSID = networkCom.joinAI(sID,currentAIIDList[list.getSelectedIndex ()-1]);
		}
	}
	
	
	/**
	 *  Open the rms db
	 */
	private void openRecordStore() {
		try
	    {
	       /** The second parameter indicates that the record store
	        * should be created if it does not exist
	        */
	      recStore = RecordStore.openRecordStore(dbRMS, true );
	    }
	    catch (Exception e)
	    {
	      System.err.println(e.toString());
	    }
	}

	/**
	 * Write a record in rms db.
	 * 
	 * @param str the string to write
	 */
	private void writeRecord(String str)
	  {
	    byte[] rec = str.getBytes();
	 
	    try
	    {
	      recStore.addRecord(rec, 0, rec.length);
	      DEBUG("Writing record: " + str);
	    }
	    catch (Exception e)
	    {
	    	System.out.println();
	      System.err.println(e.toString());
	    }
	  }
	
	
    /**********************************************************/
	/** Implementation of the herited GASP events listeners ***/
	/**********************************************************/
    
    public void onJoinEvent(int actorSessionID, String username) {
        /**
         *  the first player join the application instance is the owner
         */
        DEBUG("JoinEvent:" + actorSessionID);
        
        if (actorSessionID == aSID){
        	System.out.println("set my pseudo to:"+ username);
        	pseudoname = username;
        }
        
      /*  int i = getIndex(actorSessionID);
        DEBUG("Index of actorSessionID:"+i);
        if(i>=0){
        	// rename case
        	gameSessionPlayers.setElementAt(username,i+1);
        }
        else{*/
        	// no player with this aSID in gameSessionPlayers vector
        	firstPlayer = (htGameSessionPlayers.size()== 0);
        	//System.out.println("firstPlayer...is :"+firstPlayer);
        	htGameSessionPlayers.put(""+actorSessionID,username);
        	//firstPlayer = (gameSessionPlayers.size() == 0);
        	
            //gameSessionPlayers.insertElementAt(new Integer(actorSessionID),gameSessionPlayers.size());
            //gameSessionPlayers.insertElementAt(username,gameSessionPlayers.size());
            
            if (firstPlayer){ 
	            ownerASID = actorSessionID;
	            if (ownerASID==aSID){
	                isOwner = true;
	                alertScreen("Note: you are the owner of the game session");
	            }
	            else alertScreen("The game session owner joins: aSID>"+actorSessionID+" username>"+username);
            }
            else{
                if (actorSessionID!=aSID)
                    alertScreen("A new player joins: aSID>"+actorSessionID+" username>"+username);
            }
        //}
        
        currentScreen();
    }
    
    public void onStartEvent(int actorSessionID) {
        if (mode == 2){
        	System.out.println("StartEvent received call startGame");
 	    	alertScreen("The game session owner starts the game!");
 	    	startGame();
        }  
     }

     public void onEndEvent(int actorSessionID) {
         gameCanvas.stop();
        if (ownerASID==actorSessionID){
 	    	alertScreen("The game session owner has stopped the game! Return to waiting room.");
  	        }
         else {
         	alertScreen("The player n� "+actorSessionID+" left the game alone! ");
  	         }
         mode = 2;
         currentScreen();
     }

     public void onQuitEvent(int actorSessionID) {
     	if (mode==2){
 	        if (ownerASID == actorSessionID){
 	            alertScreen("The game session owner has left the game, the game session has been distructed." +
 	            		" Return to the Lobby.");
 	            removeAllPlayers();
 	           // gameSessionPlayers.removeAllElements();
 	            mode = 1;
 	            currentScreen();
 	        }
 	        else{
 	        	if (/*isOwner && */min>htGameSessionPlayers.size()/2 /*gameSessionPlayers.size()/2*/)
 	            	{
 	            	alertScreen("The player n�"+actorSessionID+" has left the game" +" Beware! The number of players is too low.");
 	            	removePlayer(actorSessionID);
 	            	}
 	        	else {
 	        		alertScreen("The player n�"+actorSessionID+" has left from lobby");
 	        		removePlayer(actorSessionID);
 	        	}
 	            currentScreen();
 	        }
     	}
     	if (mode == 3){
     		if (ownerASID == actorSessionID){
 	            alertScreen("The game session owner has left the game, the game has been distructed." +
 	            		" Return to the Lobby Room.");
 	            removeAllPlayers();
 	            //gameSessionPlayers.removeAllElements();
 	            mode = 1;
 	            currentScreen();
 	        }
     		else{
     			//gameSessionPlayers.removeElementAt(actorSessionID);
     			removePlayer(actorSessionID);
     			//System.out.println("GameSessionPlayers.size()/2 is: "+gameSessionPlayers.size()/2);
   				if (/*isOwner &&*/min>htGameSessionPlayers.size()/2 /*gameSessionPlayers.size()/2*/)
 	            	{
 	        		alertScreen("The player n�"+actorSessionID+" has left the game" +" Beware! The number of players is too low.");
 	        		mode = 2;
 	            	currentScreen();
 	            	}
 	        	else {
 	        		alertScreen("The player n�"+actorSessionID+" has left the game and go to lobby room or GASP log on");
 	        	    gameCanvas.onQuitEvent(actorSessionID);
 	        		display.setCurrent(gameCanvas);
 	        	}
 	        	
 	        }
     	}
     }
     
     
     public void onDataEvent(int actorSessionID, Hashtable datas) {
         if (mode == 2){
         	System.out.println("DataEvent received (WR)");
         	int nbSend = datas.size();
     		for (int i = 0; i < nbSend; i++) {
     			Object o = (Object) datas.get("" + i);
     			
     			String txt = "";
     			int id = 0;
     			
     			if (o instanceof ChatMessageBroadcast){
     				ChatMessageBroadcast c = (ChatMessageBroadcast) o;
     				txt = c.getTxt();
     				id = c.getId();
     			}
     			
     		    if (o instanceof ChatMessageMulticast){
     		    	ChatMessageMulticast c = (ChatMessageMulticast) o;
     				txt = c.getTxt();
     				id = c.getId();
         		}
         				
         	    if (o instanceof ChatMessageUnicast){
         	    	ChatMessageUnicast c = (ChatMessageUnicast) o;
     				txt = c.getTxt();
     				id = c.getId();
             	}
         	    
         	    tfChat.setLabel(tfChat.getLabel()+"\n"+htGameSessionPlayers.get(""+id)+": "+txt);
         	    System.out.println("chat message received from "+id+ " txt:"+txt);
     		}
         }
         
         else if (mode == 3){
         	gameCanvas.onDataEvent(actorSessionID, datas);
         }
     }
     
   
    /*********************************/
    /******* GAME MANAGEMENT *********/
    /*********************************/
    
    /**
     * game canvas link
     */
    protected GameCanvas gameCanvas;
    
    public void startGame() {
    	System.out.println("The game starts!");
    	mode = 3;
        /** 
         * initialize game
         */
    	gameCanvas = new SimpleGameCanvas(app, this, (int) NetworkCom.minimalRequestDeltaTime);
        gameCanvas.initialize();
        
        /**
         *  set game display
         */
        display.setCurrent(gameCanvas);
        
        /**
         *  start game
         */
		gameCanvas.newGame();
		gameCanvas.restart();
		
		//#ifdef GPS_SIMULATOR
    	gpsProvider = new GPSProvider(this);
    	//#endif GPS_SIMULATOR
    }
    
   
    /**
     * Remove the player corresponding to the actorSessionID.
     * 
     * @param actorSessionID
     */
    private short getPlayerASID(int index) {
    	try {
    		Enumeration enume = htGameSessionPlayers.keys();
    		int count = 0;
    		
    		while (count <= index && enume.hasMoreElements()){
    			String key = (String) enume.nextElement(); 
    			System.out.println("key id: "+key);
    			if (count == index) return Short.parseShort(key);
    			count++;
    		}
    	}
    	catch (Exception e){
    		System.out.println("a pb occurs in getPlayerASID");
    		e.printStackTrace();
    	}
    	return -1;
    }
    
    
    /**
     * Remove the player corresponding to the actorSessionID.
     * 
     * @param actorSessionID
     */
    private void removePlayer(int actorSessionID) {
    	try {
    		Enumeration enume = htGameSessionPlayers.keys();
    		while (enume.hasMoreElements()){
    			short pid =Short.parseShort((String) enume.nextElement());
    			if (actorSessionID==pid){
    				htGameSessionPlayers.remove(""+actorSessionID);
    			}
    		}
    	}
    	catch (Exception e){
    		System.out.println("a pb occurs in RemovePlayer");
    		e.printStackTrace();
    	}
    }
    
    
  /*  private void removePlayer(int actorSessionID) {
    	try {
        	for(int i=0; i<gameSessionPlayers.size();i++){
                if (((Integer) gameSessionPlayers.elementAt(i)).intValue() == actorSessionID){
                  gameSessionPlayers.removeElementAt(i);
                break;
               }
               i++;
           }
    	}
    	catch (Exception e){
    	}
    }*/
 
    /**
     * Remove all the players
     */
    
    private void removeAllPlayers(){
    	Enumeration enume=htGameSessionPlayers.keys();
    	while (enume.hasMoreElements()){
    		short pid =Short.parseShort((String) enume.nextElement());
    		removePlayer(pid);
    	}
    }
    
	/**
	 * @return Returns the mode.
	 */
	public int getMode() {
		return mode;
	}

	/***************************************************************************/
	/************************  Link to NetworkCom  *****************************/
	/**These methods are used to transmit an event from IHMGasp to NetworkCom**/
	/**************************************************************************/
	
	public void endAI() {
		networkCom.endAI(aSID);
	}


	public void quitAI() {
		networkCom.quitAI(aSID);
	}


	public void quit() {
		networkCom.quit(sID);
	}
	
	/**
	 * method is used to transmit a message from GameCanvas to NetworkCom
	 */
	public void sendMessage(Object o) {
		networkCom.addMessageToSend(o);
	}
	
	//#ifdef VIRTUAL_WORLD_MAP
	//# public Object update() {
		//# return gameCanvas.cyclicUpdateMessagesToSend();
	//# }
	//#endif VIRTUAL_WORLD_MAP
	
	//#ifdef PING
	//# public Object ping() {
		//# return gameCanvas.cyclicPingPlayerMessagesToSend();
	//# }
	//#endif PING
	
	
	/***************************************************************************/
	/** Link to MapCom                                                        **/
	/** These methods are used to transmit an event between GameCanvas/MapCom **/
	/***************************************************************************/
	
	public void newMap(Image map) {
		gameCanvas.newMap(map);
		
	}
	public void mapRequest(double lat, double lon, int zoom, int width, int height) {
		mapCom.mapRequest(lat, lon, zoom, width, height);
	}

    /***************************************************************************/
	/** Location management                                                   **/
	/***************************************************************************/

    public Object updateLocation() {
		// TODO Auto-generated method stub
		return gameCanvas.updateLocation();
	}
    
    public void requireMapRequest() {
		gameCanvas.requireMapRequest();
	}
    
    public void fix(String utc, double lat, double lon, int nsat,
			double accuracy, double altitude) {
		gameCanvas.fix(utc, lat, lon, nsat, accuracy, altitude);
	}
    
    public void failed(Throwable th) {
		// TODO Auto-generated method stub
	}
    
	/***************************************************************************/
	/** Bluetooth GPS connection management                                   **/
	/** These methods are used to transmit an event between GameCanvas/MapCom **/
	/***************************************************************************/
    
    //#ifdef GPS_SIMULATOR
    GPSProvider gpsProvider;
    //#endif GPS_SIMULATOR

	//#ifdef GPS_BLUETOOTH
    //# private Alert alert = new Alert(null);
	//# private Discovery discovery = null;
	//# private Form mainForm;
    //# private Command connectCommand;
    //# private ChoiceGroup deviceGroup;
    //# public  StringItem status;
	//# 
    //# public void alert(final AlertType type, final String message, final Throwable th) {
        //# alert.setType(type);
        //# alert.setTimeout(1500);
        //# final String exMsg = th == null ? null : th.getMessage();
        //# final String text = exMsg == null ? message : message + ": " + exMsg;
        //# alert.setString(text);
        //# display.setCurrent(alert, mainForm);
    //# }
    //# 
    //# public void status(final String message) {
        //# alert.setString(message);
        //# System.out.println(message);
        //# status.setText(message);
    //# }
    //# 
    //# private void doDiscovery() {
        //# discovery = new Discovery(this);
        //# new Thread(new Runnable() {
            //# public void run() {
                //# try {
                    //# discovery.performDiscovery();
                //# } catch (Exception ex) {
                    //# alert(AlertType.ERROR, "discovery", ex);
                //# }
            //# }
        //# }).start();
    //# }
    //# 
    //# private void doConnect() {
    	//# try {
			//# discovery.searchServices(this);
			//# mode = 1;
			//# currentScreen();
		//# } catch (BluetoothStateException e) {
			//# // TODO Auto-generated catch block
			//# e.printStackTrace();
		//# } catch (IOException e) {
			//# // TODO Auto-generated catch block
			//# e.printStackTrace();
		//# }
    //# }
	//# 
    //# /** This method returns instance for mainForm component and should be called instead of accessing mainForm field directly.
     //# * @return Instance for mainForm component
     //# */
    //# public Form get_mainForm() {
        //# if (mainForm == null) {
            //# // Insert pre-init code here
            //# mainForm = new Form("GPS client", new Item[] {
                //# get_deviceGroup(),
                //# get_status()
            //# });
            //# mainForm.addCommand(get_exitCommand());
            //# mainForm.setCommandListener(this);
            //# // Insert post-init code here
        //# }
        //# return mainForm;
    //# }
    //# 
    //# /** This method returns instance for exitCommand component and should be called instead of accessing exitCommand field directly.
     //# * @return Instance for exitCommand component
     //# */
    //# public Command get_exitCommand() {
        //# if (exitCommand == null) {//GEN-END:MVDGetBegin3
            //# // Insert pre-init code here
            //# exitCommand = new Command("Exit", Command.EXIT, 1);
            //# // Insert post-init code here
        //# }
        //# return exitCommand;
    //# }
    //# 
    //# /** This method returns instance for connectCommand component and should be called instead of accessing connectCommand field directly.//GEN-BEGIN:MVDGetBegin9
     //# * @return Instance for connectCommand component
     //# */
    //# public Command get_connectCommand() {
        //# if (connectCommand == null) {//GEN-END:MVDGetBegin9
            //# // Insert pre-init code here
            //# connectCommand = new Command("Connect", Command.ITEM, 1);//GEN-LINE:MVDGetInit9
            //# // Insert post-init code here
        //# }//GEN-BEGIN:MVDGetEnd9
        //# return connectCommand;
    //# }//GEN-END:MVDGetEnd9
    //# 
    //# /** This method returns instance for deviceGroup component and should be called instead of accessing deviceGroup field directly.//GEN-BEGIN:MVDGetBegin11
     //# * @return Instance for deviceGroup component
     //# */
    //# public ChoiceGroup get_deviceGroup() {
        //# if (deviceGroup == null) {//GEN-END:MVDGetBegin11
            //# // Insert pre-init code here
            //# deviceGroup = new ChoiceGroup("Devices:", Choice.POPUP, new String[0], new Image[0]);//GEN-BEGIN:MVDGetInit11
            //# deviceGroup.setSelectedFlags(new boolean[0]);
            //# deviceGroup.setFitPolicy(Choice.TEXT_WRAP_OFF);//GEN-END:MVDGetInit11
            //# // Insert post-init code here
        //# }//GEN-BEGIN:MVDGetEnd11
        //# return deviceGroup;
    //# }//GEN-END:MVDGetEnd11
    //# 
    //# 
    //# 
    //# 
    //# /** This method returns instance for status component and should be called instead of accessing status field directly.//GEN-BEGIN:MVDGetBegin17
     //# * @return Instance for status component
     //# */
    //# public StringItem get_status() {
        //# if (status == null) {//GEN-END:MVDGetBegin17
            //# // Insert pre-init code here
            //# status = new StringItem("Status:", "");//GEN-LINE:MVDGetInit17
            //# // Insert post-init code here
        //# }//GEN-BEGIN:MVDGetEnd17
        //# return status;
    //# }//GEN-END:MVDGetEnd17
	//# 
    //# 
    //# 
    //#endif GPS_BLUETOOTH
}
	
    
	
