/***
 * uGASP location based demonstrator.
 * Copyright (C) 2008 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin
 */

/** 
 * MooDS Encoder/Decoder for Flash.
 * Encoding version: 1200
 * @author Generated by MooDS Generator v2.1.0 - 2006 CNAM, INT, Filao 
 */

package org.ugasp.demonstrator.client;

import org.ugasp.demonstrator.*;
import java.util.Hashtable;
import java.io.DataOutputStream;
import java.io.DataInputStream;

//This class has been generated by MooDS Generator to handle objects
// for binarisation input/output.
public class CustomTypes {

	// types
	public final static byte TYPE_NEWPLAYER = 1;
	public final static byte TYPE_LOCATIONEVENT = 2;
	public final static byte TYPE_MAPREQUEST = 3;
	public final static byte TYPE_MAPRESPONSE = 4;
	public final static byte TYPE_CHATMESSAGEBROADCAST = 5;
	public final static byte TYPE_CHATMESSAGEMULTICAST = 6;
	public final static byte TYPE_CHATMESSAGEUNICAST = 7;


	// encodeData root method
	public static void encodeData(Hashtable h,DataOutputStream dos) throws Exception {
		dos.writeShort(1200);
		dos.writeShort(h.size());
		int nbSend = h.size();
		for(int i=0; i <nbSend; i++){
			Object o = h.get(""+i);
			if (o instanceof NewPlayer) {
				dos.writeByte(TYPE_NEWPLAYER);
				encodeNewPlayer(dos,((NewPlayer) o));
			}
			if (o instanceof LocationEvent) {
				dos.writeByte(TYPE_LOCATIONEVENT);
				encodeLocationEvent(dos,((LocationEvent) o));
			}
			if (o instanceof MapRequest) {
				dos.writeByte(TYPE_MAPREQUEST);
				encodeMapRequest(dos,((MapRequest) o));
			}
			if (o instanceof MapResponse) {
				dos.writeByte(TYPE_MAPRESPONSE);
				encodeMapResponse(dos,((MapResponse) o));
			}
			if (o instanceof ChatMessageBroadcast) {
				dos.writeByte(TYPE_CHATMESSAGEBROADCAST);
				encodeChatMessageBroadcast(dos,((ChatMessageBroadcast) o));
			}
			if (o instanceof ChatMessageMulticast) {
				dos.writeByte(TYPE_CHATMESSAGEMULTICAST);
				encodeChatMessageMulticast(dos,((ChatMessageMulticast) o));
			}
			if (o instanceof ChatMessageUnicast) {
				dos.writeByte(TYPE_CHATMESSAGEUNICAST);
				encodeChatMessageUnicast(dos,((ChatMessageUnicast) o));
			}
		}
	}


	// decodeData rooy method
	public static Hashtable decodeData(DataInputStream dis) throws Exception {
		dis.readShort();
		Hashtable h = new Hashtable();
		short nb = dis.readShort();
		int nbObj = nb;
		while (nb != 0) {
			String key = ""+(nbObj - nb);
			byte type = dis.readByte();
			if (type == 1) {
				NewPlayer customType = decodeNewPlayer(dis);
				h.put(key,customType);
			}
			if (type == 2) {
				LocationEvent customType = decodeLocationEvent(dis);
				h.put(key,customType);
			}
			if (type == 3) {
				MapRequest customType = decodeMapRequest(dis);
				h.put(key,customType);
			}
			if (type == 4) {
				MapResponse customType = decodeMapResponse(dis);
				h.put(key,customType);
			}
			if (type == 5) {
				ChatMessageBroadcast customType = decodeChatMessageBroadcast(dis);
				h.put(key,customType);
			}
			if (type == 6) {
				ChatMessageMulticast customType = decodeChatMessageMulticast(dis);
				h.put(key,customType);
			}
			if (type == 7) {
				ChatMessageUnicast customType = decodeChatMessageUnicast(dis);
				h.put(key,customType);
			}
			nb--;
		}
		return h;
	}


	// encoding method for each custom type
	private static void encodeNewPlayer(DataOutputStream dos,NewPlayer customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeInt(customType.getX());
		dos.writeInt(customType.getY());
		System.out.println("encodeNewPlayer, username:"+customType.getUsername());
		dos.writeUTF(customType.getUsername());
	}


	private static void encodeLocationEvent(DataOutputStream dos,LocationEvent customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeDouble(customType.getLatitude());
		dos.writeDouble(customType.getLongitude());
		dos.writeInt(customType.getProjectedX());
		dos.writeInt(customType.getProjectedY());
	}


	private static void encodeMapRequest(DataOutputStream dos,MapRequest customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeByte(customType.getZoom());
		dos.writeInt(customType.getWidth());
		dos.writeInt(customType.getHeight());
		dos.writeDouble(customType.getLatitude());
		dos.writeDouble(customType.getLongitude());
	}


	private static void encodeMapResponse(DataOutputStream dos,MapResponse customType) throws Exception {
		PlayerCoordinates[] table1 = customType.getPlayerCoordinates();
		int table1_l0 = table1.length;
		dos.writeInt((int) table1_l0);
		if (table1_l0>0) {
			for(int i0=0; i0 <table1_l0; i0++){
				encodePlayerCoordinates(dos,table1[i0]);
			}
		}

	}


	private static void encodePlayerCoordinates(DataOutputStream dos,PlayerCoordinates customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeInt(customType.getX());
		dos.writeInt(customType.getY());
	}


	private static void encodeChatMessageBroadcast(DataOutputStream dos,ChatMessageBroadcast customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeUTF(customType.getTxt());
	}


	private static void encodeChatMessageMulticast(DataOutputStream dos,ChatMessageMulticast customType) throws Exception {
		multicastRecipientsEncoding(dos,customType.getRecipients());
		dos.writeShort(customType.getId());
		dos.writeUTF(customType.getTxt());
	}


	private static void encodeChatMessageUnicast(DataOutputStream dos,ChatMessageUnicast customType) throws Exception {
		unicastRecipientEncoding(dos,customType.getRecipient());
		dos.writeShort(customType.getId());
		dos.writeUTF(customType.getTxt());
	}



	// decoding method for each custom type
	public static NewPlayer decodeNewPlayer(DataInputStream dis) throws Exception {
		NewPlayer customType = new NewPlayer();

		customType.setId(dis.readShort());
		customType.setX(dis.readInt());
		customType.setY(dis.readInt());
		customType.setUsername(dis.readUTF());
		return customType;
	}


	public static LocationEvent decodeLocationEvent(DataInputStream dis) throws Exception {
		LocationEvent customType = new LocationEvent();

		customType.setId(dis.readShort());
		customType.setLatitude(dis.readDouble());
		customType.setLongitude(dis.readDouble());
		customType.setProjectedX(dis.readInt());
		customType.setProjectedY(dis.readInt());
		return customType;
	}


	public static MapRequest decodeMapRequest(DataInputStream dis) throws Exception {
		MapRequest customType = new MapRequest();

		customType.setId(dis.readShort());
		customType.setZoom(dis.readByte());
		customType.setWidth(dis.readInt());
		customType.setHeight(dis.readInt());
		customType.setLatitude(dis.readDouble());
		customType.setLongitude(dis.readDouble());
		return customType;
	}


	public static MapResponse decodeMapResponse(DataInputStream dis) throws Exception {
		MapResponse customType = new MapResponse();

		int table1_l0 = dis.readInt();
		if (table1_l0>0) {
			PlayerCoordinates[] table1 = new PlayerCoordinates[table1_l0];
			for(int i0=0; i0 <table1_l0; i0++){
				table1[i0] = decodePlayerCoordinates(dis);
			}
			customType.setPlayerCoordinates(table1);
		}
		return customType;
	}


	public static PlayerCoordinates decodePlayerCoordinates(DataInputStream dis) throws Exception {
		PlayerCoordinates customType = new PlayerCoordinates();

		customType.setId(dis.readShort());
		customType.setX(dis.readInt());
		customType.setY(dis.readInt());
		return customType;
	}


	public static ChatMessageBroadcast decodeChatMessageBroadcast(DataInputStream dis) throws Exception {
		ChatMessageBroadcast customType = new ChatMessageBroadcast();

		customType.setId(dis.readShort());
		customType.setTxt(dis.readUTF());
		return customType;
	}


	public static ChatMessageMulticast decodeChatMessageMulticast(DataInputStream dis) throws Exception {
		short[] recipients = multicastRecipientsDecoding(dis);;
		ChatMessageMulticast customType = new ChatMessageMulticast(recipients);

		customType.setId(dis.readShort());
		customType.setTxt(dis.readUTF());
		return customType;
	}


	public static ChatMessageUnicast decodeChatMessageUnicast(DataInputStream dis) throws Exception {
		short recipient = unicastRecipientDecoding(dis);;
		ChatMessageUnicast customType = new ChatMessageUnicast(recipient);

		customType.setId(dis.readShort());
		customType.setTxt(dis.readUTF());
		return customType;
	}



	// multicast communication methods
	private static void multicastRecipientsEncoding(DataOutputStream dos,short[] recipients) throws Exception {
		dos.writeByte((byte) recipients.length);
		for(int i=0; i <recipients.length; i++){
			dos.writeShort(recipients[i]);
		}
	}

	private static short[] multicastRecipientsDecoding(DataInputStream dis) throws Exception {
		short[] recipients = new short[dis.readByte()];
		for(int i=0; i <recipients.length; i++){
			recipients[i] = dis.readShort();
		}
		return recipients;
	}

	// unicast communication methods
	private static void unicastRecipientEncoding(DataOutputStream dos,short recipient) throws Exception {
		dos.writeShort(recipient);
	}

	private static short unicastRecipientDecoding(DataInputStream dis) throws Exception {
		return dis.readShort();
	}

}
