/***
 * uGASP location based demonstrator.
 * Copyright (C) 2008 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin
 */
//#include parameters.h
////////////////////////
// Compile params     //
////////////////////////



////////////////////////
// Game params        //
////////////////////////

////#define PING
////#define VIRTUAL_WORLD_MAP

////////////////////////
// Mobile Ajax params //
////////////////////////


////////////////////
// Logging params //
////////////////////

// enable to log in a mobile phone file (Nokia videos folder)
// we used the JSR75 
////#define LOG_FILE 


//#endinclude
package org.ugasp.demonstrator.client;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.microedition.lcdui.Image;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

import org.ugasp.demonstrator.ChatMessageBroadcast;
import org.ugasp.demonstrator.ChatMessageMulticast;
import org.ugasp.demonstrator.ChatMessageUnicast;
import org.ugasp.demonstrator.NewPlayer;

import com.sun.me.web.request.Arg;

//#ifdef PING
//# import org.ugasp.demonstrator.PingPlayer;
//#endif PING

//#ifdef VIRTUAL_WORLD_MAP
//# import org.ugasp.demonstrator.UpdatePlayer;
//#endif VIRTUAL_WORLD_MAP

/**
 * @author Romain PELLERIN
 *
 */
public class MapCom implements Runnable{
	
	private static final boolean DEBUG = true;
	private IHMGasp ihmGasp;
	private Thread comThread;
	private static boolean mapRequest = false;
	private static double latitude;
	private static double longitude;
	private static int zoomLevel;
	private static int width;
	private static int height;
	public final static long  minimalRequestDeltaTime = 10000;
	private static long lastMapRequest = 0;
	
	public MapCom(IHMGasp c){
		this.ihmGasp=c;
		comThread = new Thread(this);
		comThread.start();
	}

	public static void mapRequest(double lat, double lon, int zoom, int width_, int height_) {
		mapRequest = true;
		latitude = lat;
		longitude = lon;
		zoomLevel = zoom;
		width = width_;
		height = height_;
	}
	
	public void run() {
		try {
			int mode;
			
			while(true) {
				mode=ihmGasp.getMode();

				if (mode==2 || mode==3){
					if (mapRequest){
						// map refresh
						System.out.println("get map");
						Image map = getMap();
						ihmGasp.newMap(map);
						mapRequest = false;
						lastMapRequest = System.currentTimeMillis();
					}
					else if (lastMapRequest != 0){	
						// force to refresh map
						long timeToSleep = minimalRequestDeltaTime - (System.currentTimeMillis() - lastMapRequest);
						if (timeToSleep <= 0){
							System.out.println("periodic map refresh");
							ihmGasp.requireMapRequest();
						}
					}
					
				}
				
				Thread.sleep(500);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
    private Image getMap() {
    	try{
    		String mapUrl = httpMapRequest(latitude,longitude,zoomLevel,width,height);
//    		byte[] data = httpMapContentRequest(resultUrl);
//    		String s = new String(data);
//    		System.out.println("data: "+data+" length:"+data.length+" stringed:"+s);
//    		return Image.createImage(data,0,data.length);	
    		return Image.createImage(httpMapContentRequest(mapUrl));
    	}
    	catch (Exception e){System.out.println("Error during map request:"+e.getMessage());}
        finally{closeAllConnection();}
    	return null;
	}

    private boolean threadStarted = false;

	public void startComThread(){
		System.out.println("NetworkCom start thread!");
		if (!threadStarted){
			//comThread.start();
			threadStarted = true;
		}
	}
	
	private static String mapProviderURL = "http://api.local.yahoo.com/MapsService/V1/mapImage";
	private String YAHOOMAPS_ID = "_fx2RaPV34E0fvlK_s.pGEiKR.hJHFI7YyTPIT8YK4bx4Lc9CGcft3BUaqNcCJ6EWwq8oMfx";
	
	static protected HttpConnection connection = null;
	static private DataOutputStream dos = null;
	static private DataInputStream dis = null;
	
	/**
	 * Send a request to the map provider
	 * 
	 * @param servletName the name of the servlet
	 * @param formData the HTTP post parameters 
	 * @return the DataInputStream
	 * @throws IOException
	 */
    private String httpMapRequest(double lat, double lon, int zoom, int width, int height) throws IOException{
    	String formData = "?"
    						+"appid="
    						+YAHOOMAPS_ID
    						+"&latitude="+lat
    						+"&longitude="+lon
    						+"&zoom="+zoom
    						+"&image_width="+width 
    						+"&image_height="+height;
        
    	System.out.println("URL:"+mapProviderURL+formData);
    	
    	connection = (HttpConnection) Connector.open(
        								mapProviderURL+formData,
										Connector.READ,
										true);
        System.out.println("");
		connection.setRequestMethod(HttpConnection.GET);
		connection.setRequestProperty("Accept", "text/xml");
		
		if (connection.getResponseCode() == HttpConnection.HTTP_OK){
			connection.getLength();
			System.out.println("content type: "+connection.getType()+"-"+connection.getHeaderFieldInt(Arg.CONTENT_LENGTH, 0));
			System.out.println("content length: "+connection.getLength()+"-"+connection.getHeaderFieldInt(Arg.CONTENT_LENGTH, 0));
			byte[] data = new byte[50000];
			
    		dis = connection.openDataInputStream();
    		String s = "";
    		
    		int index = 0;
    	  	while(true){
	    		byte b = (byte) dis.read();
	    		if (b == -1) break;
	    		
	    		s += (char) b;
	    		//data[index] = b;
	    		index++;
	    	}
    	  	
    	  	// mini parser of result content
    	  	// index of '<'Result'>
    	  	boolean resultFound = false;
    	  	int _index = 0;
    	  	int count = 0;
    	  	
    	  	while (!resultFound){
    	  		int indexOf = s.indexOf('<',_index);
    	  		if (indexOf == -1) break;
    	  		
    	  		String sub = s.substring(indexOf+1, indexOf+1+6);
    	  		System.out.println("is Result ? "+ sub);
    	  		
    	  		resultFound = sub.equals("Result");
    	  		
    	  		_index = s.indexOf('>',_index)+1; //>_
    	  		count++;
    	  	}
    	  	
    	  	// get <Result> url content
    	  	int end = s.indexOf('<', _index);
    	  	String resultUrl = s.substring(_index,end);
    	  	
    	  	System.out.println("url:"+resultUrl);
			System.out.println("http ok");
			return resultUrl;
		}
		
		else return "";
	}
    
    
    /**
	 * Send a request to the map provider
	 * 
	 * @param servletName the name of the servlet
	 * @param formData the HTTP post parameters 
	 * @return the DataInputStream
	 * @throws IOException
	 */
    private DataInputStream httpMapContentRequest(String mapUrl) throws IOException{
    	connection = (HttpConnection) Connector.open(
    									mapUrl,
										Connector.READ,
										true);
        System.out.println("");
		connection.setRequestMethod(HttpConnection.GET);
		connection.setRequestProperty("Accept", "image/png");
		
		if (connection.getResponseCode() == HttpConnection.HTTP_OK){
			connection.getLength();
			
			System.out.println("content type: "+connection.getType()+"-"+connection.getHeaderFieldInt(Arg.CONTENT_LENGTH, 0));
			System.out.println("content length: "+connection.getLength()+"-"+connection.getHeaderFieldInt(Arg.CONTENT_LENGTH, 0));
			
			return connection.openDataInputStream();
//			String s = "";
//    		
//    		int index = 0;
//    	  	while(true){
//	    		byte b = (byte) dis.read();
//	    		if (b == -1) break;
//	    		
//	    		s += (char) b;
//	    		//data[index] = b;
//	    		index++;
//	    	}
//    	  	System.out.println("s:"+s);
//    	  	
//			return s.getBytes();
		}
		else return null;
	}
    
    /**
	 * Close all connection streams and the connection.
	 */
	static private void closeAllConnection(){
	    if (dis != null) { try {dis.close();} catch (Exception _e){}}				
		if (dos != null) { try {dos.close();} catch (Exception _e){}}
	    if (connection !=null) {try {connection.close();} catch (Exception e){}}
		connection = null;
	}

	
}
